//+------------------------------------------------------------------+
//|                                            Bollinger Band EA.mq4 |
//|                                            Copyright  Rich 2012 |
//|  Unauthorized use will be punished by the full extent of the law |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Rich"
#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern string ExpertName = "Bollinger Band EA";
extern int MagicNumber = 12345;
extern int MaxSpread = 4;
extern int MaxSlippage = 4;
extern int GMTOFFSET = 0;
extern string Manage = "== Order Management ==";
extern int Periods = 20;
extern int Deviations = 2;
extern int Shift = 0;
extern int Buffer = 0;
extern bool Monday = TRUE;
extern bool Tuesday = TRUE;
extern bool Wednesday = TRUE;
extern bool Thursday = TRUE;
extern bool Friday = TRUE;
extern int HourStart = 0;
extern int HourEnd = 23;
extern int StopLoss = 300;
extern int TakeProfit = 300;
extern double RiskPercent = 5;
extern double MaxRisk = 5;
extern double RiskMpOnLoss = 1;
extern bool RiskResetOnProfit = true;
extern int RecoveryTrades = 1;
extern int OpenOrdersLimit = 1;
extern int NewTakeProfit = 0;
extern int Slippage = 4;
extern double BreakEvenRisk = 50;
extern double MinLot = 0.1;

// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;

datetime BarTime5 = 0;
double CurrentRisk = 1;
bool FirstBuyRiskMgm7 = true;
datetime BarTime9 = 0;
bool FirstSellRiskMgm22 = true;
int Today = -1;
int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
     CurrentRisk = RiskPercent;
     
    Comment("");    // clear the chart
}

// Expert start
int start()
{


    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick1();
    
}

void OnEveryTick1()
{
    if (true == false && false) PipValue = 10;
    if (true && (NDigits == 3 || NDigits == 5)) PipValue = 10;
   WeekdayFilter();
}

void WeekdayFilter() {
   if ((Monday && DayOfWeek() == 1) || (Tuesday && DayOfWeek() == 2) || (Wednesday && DayOfWeek() == 3) || (Thursday && DayOfWeek() == 4) || (Friday && DayOfWeek() == 5) ||
      (DayOfWeek() == 6 && 0) || (DayOfWeek() == 0 && 0)) {
      HoursFilter();
   }
}

datetime TimeGMT(){ // TimeCurrent to GMT
    datetime    now = TimeCurrent();                // Under tester, TimeLocal
    return (now + GMTOFFSET*3600);
}

void HoursFilter()
{
    datetime    now = TimeGMT();
    int hour0 = TimeHour(now);
    
   
     if ((HourStart < HourEnd && hour0 >= HourStart && hour0 < HourEnd) ||
    (HourStart > HourEnd && (hour0 < HourEnd || hour0 >= HourStart)))
    {
        TechnicalAnalysis1();
       TechnicalAnalysis2();   
        BreakEven();
    }
    }
    

void BreakEven()
{
    double lots = 0;
    double takeprofit = 0;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
            if (OrderType() == OP_BUY && (Ask - OrderOpenPrice()) > (OrderOpenPrice() - OrderStopLoss())*2
            && (OrderStopLoss() < OrderOpenPrice()))
            {
                lots = (OrderLots() * BreakEvenRisk) / 100;
                lots = NormalizeDouble(lots, NDigits);
                if (lots < MarketInfo(Symbol(), MODE_MINLOT))    // make sure lot is not smaller than allowed value
                lots = MarketInfo(Symbol(), MODE_MINLOT);
                takeprofit = Ask+NewTakeProfit*PipValue*Point;
                if (NewTakeProfit == 0) takeprofit = OrderTakeProfit();
                bool ret1 = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), takeprofit, OrderExpiration(), White);
                if (ret1 == false)
                Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                else if (OrderLots() >= MinLot)
                {
                    ret1 = OrderClose(OrderTicket(), lots, OrderClosePrice(), MaxSlippage, White);
                    if (ret1 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
                
            }
           if (OrderType() == OP_SELL && (OrderOpenPrice() - Bid > OrderStopLoss() - OrderOpenPrice())*2
           && (OrderStopLoss() > OrderOpenPrice()))
            {
                lots = (OrderLots() * BreakEvenRisk) / 100;
                lots = NormalizeDouble(lots, NDigits);
                if (lots < MarketInfo(Symbol(), MODE_MINLOT))    // make sure lot is not smaller than allowed value
                lots = MarketInfo(Symbol(), MODE_MINLOT);
                takeprofit = Bid-NewTakeProfit*PipValue*Point;
                if (NewTakeProfit == 0) takeprofit = OrderTakeProfit();
                bool ret2 = OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), takeprofit, OrderExpiration(), White);
                if (ret2 == false)
                Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                else if (OrderLots() >= MinLot)
                {
                    ret2 = OrderClose(OrderTicket(), lots, OrderClosePrice(), MaxSlippage, White);
                    if (ret2 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
                
            }
            
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}

void TechnicalAnalysis1()
{
    if ((Low[1] > iBands(NULL, NULL,Periods,Deviations,Shift,PRICE_CLOSE,MODE_UPPER,1)) && (Open[0] > iBands(NULL, NULL,20,0,2,PRICE_CLOSE,MODE_UPPER,0)))
    {
        OncePerBar5();
        
    }
}

void TechnicalAnalysis2()
{
    if ((High[1] < iBands(NULL, NULL,Periods,Deviations,Shift,PRICE_CLOSE,MODE_LOWER,1)) && (Open[0] < iBands(NULL, NULL,20,0,2,PRICE_CLOSE,MODE_LOWER,0)))
    {
        OncePerBar9();
        
    }
}


void OncePerBar5()
{
    
    if (BarTime5 < Time[0])
    {
        // we have a new bar opened
        BarTime5 = Time[0]; // keep the new bar open time
        LimitOpenOrders6();
        
    }
}

void LimitOpenOrders6()
{
    int count = 0;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol())
        if (OrderMagicNumber() == MagicNumber)
        {
            count++;
        }
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    if (count < OpenOrdersLimit)
    {
        BuyOrderRisk();
        
    }
}


void OncePerBar9()
{
    
    if (BarTime9 < Time[0])
    {
        // we have a new bar opened
        BarTime9 = Time[0]; // keep the new bar open time
        LimitOpenOrders10();
        
    }
}

void LimitOpenOrders10()
{
    int count = 0;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol())
        if (OrderMagicNumber() == MagicNumber)
        {
            count++;
        }
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    if (count < OpenOrdersLimit)
    {
        SellOrderRisk();
        
    }
}


bool ProfitHistoryOrdersCount(int count){
    int ProfitHistoryOrdersCount = 0;
    for (int i = OrdersHistoryTotal()-1; i >=0; i--) if(
        OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)
    &&  OrderSymbol()      == Symbol()
    &&  OrderMagicNumber() == MagicNumber
    &&  OrderType()        <= OP_SELL  
    )   
      {
      if (OrderProfit() > 0) ProfitHistoryOrdersCount++;
      if (ProfitHistoryOrdersCount == count) return(true);
      if(OrderProfit() <= 0) return (false);
      } 
}


void BuyOrderRisk()
{
    double profit = 0;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            profit = OrderProfit();
        }
    }
    if (ProfitHistoryOrdersCount(RecoveryTrades)) 
    {
        if (RiskResetOnProfit)
        CurrentRisk = RiskPercent;
    }
    else if (profit < 0)
    {
        CurrentRisk = CurrentRisk * RiskMpOnLoss;
    }
    if (CurrentRisk > MaxRisk)
    {
        CurrentRisk = MaxRisk;
    }
    double lotsize = MarketInfo(Symbol(),MODE_LOTSIZE) / 1;
    double pipsize = 100 * 10;
    double maxlots = AccountEquity() / 100 * CurrentRisk / lotsize * pipsize;
    if (StopLoss == 0) Print("OrderSend() error - stoploss can not be zero");
    double lots = maxlots / StopLoss * 10;
    
    // calculate lot size based on current risk
    double lotvalue = 0.001;
    double minilot = MarketInfo(Symbol(), MODE_MINLOT);
    int powerscount = 0;
    while (minilot < 1)
    {
        minilot = minilot * MathPow(10, powerscount);
        powerscount++;
    }
    lotvalue = NormalizeDouble(lots, powerscount - 1);
    
    if (lotvalue < MarketInfo(Symbol(), MODE_MINLOT))    // make sure lot is not smaller than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MINLOT);
    }
    if (lotvalue > MarketInfo(Symbol(), MODE_MAXLOT))    // make sure lot is not greater than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MAXLOT);
    }
    double SL = NormalizeDouble(iBands(NULL, NULL,Periods,Deviations,0,PRICE_CLOSE,MODE_LOWER,0), NDigits) -Buffer*PipValue*Point;
    if (iBands(NULL, NULL,20,2,0,PRICE_CLOSE,MODE_LOWER,0) == 0) SL = 0;
    double TP = Ask + TakeProfit*PipValue*Point;
    if (TakeProfit == 0) TP = 0;
    
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, lotvalue, Ask, MaxSlippage, 0, 0, ExpertName, MagicNumber, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, lotvalue, Ask, MaxSlippage, SL, TP, ExpertName, MagicNumber, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}


void SellOrderRisk()
{
    double profit = 0;
    datetime lastCloseTime = 0;
    int cnt = OrdersHistoryTotal();
    for (int i=0; i < cnt; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && lastCloseTime < OrderCloseTime())
        {
            lastCloseTime = OrderCloseTime();
            profit = OrderProfit();
        }
    }
    if (ProfitHistoryOrdersCount(RecoveryTrades)) 
    {
        if (RiskResetOnProfit)
        CurrentRisk = RiskPercent;
    }
    else if (profit < 0)
    {
        CurrentRisk = CurrentRisk * RiskMpOnLoss;
    }
    if (CurrentRisk > MaxRisk)
    {
        CurrentRisk = MaxRisk;
    }
    double lotsize = MarketInfo(Symbol(),MODE_LOTSIZE) / 1;
    double pipsize = 100 * 10;
    double maxlots = AccountEquity() / 100 * CurrentRisk / lotsize * pipsize;
    if (StopLoss == 0) Print("OrderSend() error - stoploss can not be zero");
    double lots = maxlots / StopLoss * 10;
    
    // calculate lot size based on current risk
    double lotvalue = 0.001;
    double minilot = MarketInfo(Symbol(), MODE_MINLOT);
    int powerscount = 0;
    while (minilot < 1)
    {
        minilot = minilot * MathPow(10, powerscount);
        powerscount++;
    }
    lotvalue = NormalizeDouble(lots, powerscount - 1);
    
    if (lotvalue < MarketInfo(Symbol(), MODE_MINLOT))    // make sure lot is not smaller than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MINLOT);
    }
    if (lotvalue > MarketInfo(Symbol(), MODE_MAXLOT))    // make sure lot is not greater than allowed value
    {
        lotvalue = MarketInfo(Symbol(), MODE_MAXLOT);
    }
   double SL = NormalizeDouble(iBands(NULL, NULL,Periods,Deviations,0,PRICE_CLOSE,MODE_UPPER,0), NDigits)+Buffer*PipValue*Point;
    if (iBands(NULL, NULL,20,2,0,PRICE_CLOSE,MODE_UPPER,0) == 0) SL = 0;
    double TP = Bid - TakeProfit*PipValue*Point;
    if (TakeProfit == 0) TP = 0;
    
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, lotvalue, Bid, 4, 0, 0, ExpertName, MagicNumber, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, lotvalue, Bid, 4, SL, TP, ExpertName, MagicNumber, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}


            


int deinit()
{
    if (false) ObjectsDeleteAll();
    
    
}




